// ==UserScript==
// @name Flash Block
// @author Lex1
// @version 1.3.12
// @description Blocks Flash and shows placeholders instead. Press Ctrl+Shift+F or Ctrl+Alt+F for permanent unblocking on the site.
// @ujs:documentation http://ruzanow.ru/index/0-5
// @ujs:download http://ruzanow.ru/userjs/FlashBlock-text-button.js
// @exclude file://*
// @exclude http://mail.google.com/*
// @exclude http://files.mail.ru/*
// @exclude http://*megaupload.com/*
// @exclude http://*blizzard.com/*
// @exclude http://gs.statcounter.com/*
// @exclude http://*.operaunite.com/media_player/*
// @exclude http://example.com/*
// ==/UserScript==


(function(){
	var prefix = 'ujs_flashblock', cName = prefix+'_disabled';
	var css = 'object[classid$=":D27CDB6E-AE6D-11cf-96B8-444553540000"]:not(.'+cName+'),object[classid$=":d27cdb6e-ae6d-11cf-96b8-444553540000"]:not(.'+cName+'),object[codebase*="swflash.cab"]:not(.'+cName+'),object[data*=".swf"]:not(.'+cName+'),object[type="application/x-shockwave-flash"]:not(.'+cName+'),object[src*=".swf"]:not(.'+cName+'),object[codetype="application/x-shockwave-flash"]:not(.'+cName+'),embed[type="application/x-shockwave-flash"]:not(.'+cName+'),embed[src*=".swf"]:not(.'+cName+'),embed[allowscriptaccess]:not(.'+cName+'),embed[flashvars]:not(.'+cName+'),embed[wmode]:not(.'+cName+')'
	+ '{content: "Flash"; outline:1px dotted gray; color:gray;}'
	+ 'object[classid$=":166B1BCA-3F9C-11CF-8075-444553540000"]:not(.'+cName+'),object[codebase*="sw.cab"]:not(.'+cName+'),object[data*=".dcr"]:not(.'+cName+'),object[type="application/x-director"]:not(.'+cName+'),object[src*=".dcr"]:not(.'+cName+'),embed[type="application/x-director"]:not(.'+cName+'),embed[src*=".dcr"]:not(.'+cName+')'
	+ '{content: "Director"; outline:1px dotted gray; color:gray;}'
	+ 'object[classid$=":15B782AF-55D8-11D1-B477-006097098764"]:not(.'+cName+'),object[codebase*="awswaxf.cab"]:not(.'+cName+'),object[data*=".aam"]:not(.'+cName+'),object[type="application/x-authorware-map"]:not(.'+cName+'),object[src*=".aam"]:not(.'+cName+'),embed[type="application/x-authorware-map"]:not(.'+cName+'),embed[src*=".aam"]:not(.'+cName+')'
	+ '{content: "Authorware"; outline:1px dotted gray; color:gray;}'
	+ 'object[classid$="32C73088-76AE-40F7-AC40-81F62CB2C1DA"]:not(.'+cName+'),object[type="application/ag-plugin"]:not(.'+cName+'),object[type="application/x-silverlight"]:not(.'+cName+'),object[type="application/x-silverlight-2"]:not(.'+cName+'),object[source*=".xaml"]:not(.'+cName+'),object[sourceelement*="xaml"]:not(.'+cName+'),embed[type="application/ag-plugin"]:not(.'+cName+'),embed[source*=".xaml"]:not(.'+cName+')'
	+ '{content: "Silverlight"; outline:1px dotted gray; color:gray;}'
	+ 'object[classid$=":D27CDB6E-AE6D-11cf-96B8-444553540000"]:not(.'+cName+'):hover,object[classid$=":d27cdb6e-ae6d-11cf-96b8-444553540000"]:not(.'+cName+'):hover,object[codebase*="swflash.cab"]:not(.'+cName+'):hover,object[data*=".swf"]:not(.'+cName+'):hover,object[type="application/x-shockwave-flash"]:not(.'+cName+'):hover,object[src*=".swf"]:not(.'+cName+'):hover,object[codetype="application/x-shockwave-flash"]:not(.'+cName+'):hover,embed[type="application/x-shockwave-flash"]:not(.'+cName+'):hover,embed[src*=".swf"]:not(.'+cName+'):hover,embed[allowscriptaccess]:not(.'+cName+'):hover,embed[flashvars]:not(.'+cName+'):hover,embed[wmode]:not(.'+cName+'):hover,'
	+ 'object[classid$=":166B1BCA-3F9C-11CF-8075-444553540000"]:not(.'+cName+'):hover,object[codebase*="sw.cab"]:not(.'+cName+'):hover,object[data*=".dcr"]:not(.'+cName+'):hover,object[type="application/x-director"]:not(.'+cName+'):hover,object[src*=".dcr"]:not(.'+cName+'):hover,embed[type="application/x-director"]:not(.'+cName+'):hover,embed[src*=".dcr"]:not(.'+cName+'):hover,'
	+ 'object[classid$=":15B782AF-55D8-11D1-B477-006097098764"]:not(.'+cName+'):hover,object[codebase*="awswaxf.cab"]:not(.'+cName+'):hover,object[data*=".aam"]:not(.'+cName+'):hover,object[type="application/x-authorware-map"]:not(.'+cName+'):hover,object[src*=".aam"]:not(.'+cName+'):hover,embed[type="application/x-authorware-map"]:not(.'+cName+'):hover,embed[src*=".aam"]:not(.'+cName+'):hover,'
	+ 'object[classid$="32C73088-76AE-40F7-AC40-81F62CB2C1DA"]:not(.'+cName+'):hover,object[type="application/ag-plugin"]:not(.'+cName+'):hover,object[type="application/x-silverlight"]:not(.'+cName+'):hover,object[type="application/x-silverlight-2"]:not(.'+cName+'):hover,object[source*=".xaml"]:not(.'+cName+'):hover,object[sourceelement*="xaml"]:not(.'+cName+'):hover,embed[type="application/ag-plugin"]:not(.'+cName+'):hover,embed[source*=".xaml"]:not(.'+cName+'):hover'
	+ '{content:attr(src) attr(data) "\\A" attr(width) " x " attr(height); display:inline-block; outline:1px dotted black; font-size:smaller; color:black; background-color:#efefef; text-align:left; min-width:60px; min-height:30px; overflow:hidden;}';

	var addStyle = function(css){
		var s = document.createElement('style');
		s.setAttribute('type', 'text/css');
		s.setAttribute('style', 'display: none !important;');
		s.appendChild(document.createTextNode(css));
		return (document.getElementsByTagName('head')[0] || document.documentElement).appendChild(s);
	};

	var getValue = function(name){
		if(window.localStorage){
			return window.localStorage.getItem(name) || '';
		}
		else{
			var eq = name+'=', ca = document.cookie.split(';');
			for(var i = ca.length; i--;){
				var c = ca[i];
				while(c.charAt(0) == ' ')c = c.slice(1);
				if(c.indexOf(eq) == 0)return unescape(c.slice(eq.length));
			};
			return '';
		}
	};

	var setValue = function(name, value, del){
		if(window.localStorage){
			if(del){window.localStorage.removeItem(name)}else{window.localStorage.setItem(name, value)};
		}
		else{
			if(document.cookie.split(';').length < 30 && document.cookie.length-escape(getValue(name)).length+escape(value).length < 4000){
				var date = new Date();
				date.setTime(date.getTime()+((del ? -1 : 10*365)*24*60*60*1000));
				document.cookie = name+'='+escape(value)+'; expires='+date.toGMTString()+'; path=/';
			}
			else{
				alert('Cookies is full!');
			}
		}
	};

	var getVideo = function(flashvars, src){
		var getLink = function(s){var rez = s.match(/[^\s\x22=&?]+\.[^\s\x22=&?\/]*(flv|mp4)/i); return rez ? rez[0] : ''};
		var getQuery = function(s, q){var rez = s.match(new RegExp('[&?]'+q+'=([^&]+)')); return rez ? rez[1] : ''};
		var getJson = function(s, q){var rez = s.match(new RegExp('\x22'+q+'\x22:\\s*(\x22.+?\x22)')); return rez ? eval(rez[1]) : ''};
		var getURL = function(f, s){return f.match(/^(\w+:\/\/|\/|$)/) ? f : s.replace(/[#?].*$/, '').replace(/[^\/]*$/, f)};
		var decodeURL = function(s){try{return decodeURIComponent(s)}catch(e){return unescape(s)}};

		var q = '', url = location.href, flv = decodeURL(flashvars);

		if( url.indexOf('youtube.com/watch?') != -1 && (q = getQuery(flv, 'video_id')) )return 'http://www.youtube.com/get_video?video_id='+q+'&t='+getQuery(flv, 't')+'&fmt=18';
		if( url.indexOf('video.google.com/videoplay?') != -1 && (q = getQuery(src, 'videoUrl')) )return decodeURL(q);
		if( url.indexOf('metacafe.com/watch/') != -1 && (q = getQuery(flv, 'mediaURL')) )return q+'?__gda__='+getQuery(flv, 'gdaKey');
		if( url.indexOf('dailymotion.com/') != -1 && (q = getJson(flv,'hqURL') || getJson(flv,'sdURL')) )return q;
		if( url.indexOf('my-hit.ru/film/') != -1 && (q = getLink(flv)) )return q+'?start=0&id='+getQuery(flv, 'id');

		return getURL(getLink(flv) || decodeURL(getLink(src)), src);
	};

	var getParam = function(e, n){
		var v = '', r = new RegExp('^('+n+')$', 'i');
		var param = e.getElementsByTagName('param');
		for(var i = 0, p; p = param[i]; i++){
			if(p.hasAttribute('name') && p.getAttribute('name').match(r)){v = p.getAttribute('value'); break};
		};
		return v;
	};

	var addClassName = function(ele, cName){
		ele.className += (ele.className ? ' ' : '')+cName;
	};

	var delClassName = function(ele, cName){
		var a = ele.className.split(' ');
		for(var i = a.length; i--;){
			if(a[i] == cName)a.splice(i, 1);
		};
		ele.className = a.join(' ');
	};

	var isBlocked = function(ele){
		var tag = ele && ele.nodeName.toLowerCase();
		return (tag == 'embed' || tag == 'object') && /^(attr\(src\))|("(Flash|Director|Authorware|Silverlight)"$)/.test(ele.currentStyle.content || getComputedStyle(ele, null).content);
	};

	var setStatus = function(value){
		if(top == self){
			window.status = value;
			window.defaultStatus = value;
			window.setTimeout(function(){window.defaultStatus = ''}, 4000);
		}
	};

	var delStyle = function(css){
		var styles = document.getElementsByTagName('style');
		for(var i = styles.length; i--;){
			if(styles[i].innerHTML == css)styles[i].parentNode.removeChild(styles[i]);
		}
	};

	var getLng = function(){
		switch(window.navigator.language){
			case 'ru': return {
				fEnabled: 'FlashBlock \u0432\u043A\u043B\u044E\u0447\u0435\u043D',
				fDisabled: 'FlashBlock \u0432\u044B\u043A\u043B\u044E\u0447\u0435\u043D'
			};
			default: return {
				fEnabled: 'FlashBlock enabled',
				fDisabled: 'FlashBlock disabled'
			}
		}
	};

	var unblockFlash = function(e){
		var ele = e && e.target; if(!ele)return;
		var embed = ele.getElementsByTagName('embed')[0];
		if(isBlocked(ele) && !e.shiftKey && !e.altKey){
			e.preventDefault();
			e.stopPropagation();
			if(e.ctrlKey){
				// Save video with Ctrl+Click
				var src = ele.getAttribute('src') || ele.getAttribute('source') || ele.getAttribute('data') || getParam(ele, 'movie|data|src|code|filename|url|source') || (embed && embed.getAttribute('src')) || '';
				location.href = getVideo(ele.getAttribute('flashvars') || getParam(ele, 'flashvars'), src) || src;
			}
			else{
				// Unblock flash
				addClassName(ele, cName);
				if(isBlocked(embed))addClassName(embed, cName);
			}
		}
	};

	var toggle = function(block){
		var postMsg = function(msg){for(var i = 0, f = window.frames, l = f.length; i < l; i++)f[i].postMessage(msg)};
		var lng = getLng();
		if(arguments.length ? !block : getValue(prefix) != 'unblocked'){
			delStyle(css);
			setValue(prefix, 'unblocked');
			postMsg(prefix+'_disable');
			document.removeEventListener('click', unblockFlash, true);
			setStatus(lng.fDisabled);
		}
		else{
			addStyle(css);
			setValue(prefix, '', true);
			postMsg(prefix+'_enable');
			document.addEventListener('click', unblockFlash, true);
			setStatus(lng.fEnabled);
		};
		var unblockedEle = document.getElementsByClassName(cName);
		for(var i = unblockedEle.length; i--;){
			delClassName(unblockedEle[i], cName);
		}
	};

	// Non html
	if(!(document.documentElement instanceof HTMLHtmlElement))return;

	// Blocking
	if(getValue(prefix) != 'unblocked'){
		addStyle(css);
		document.addEventListener('click', unblockFlash, true);
	};

	// Unblock for the site with Ctrl+Shift+F or Ctrl+Alt+F
	document.addEventListener('keypress', function(e){
		if(e.keyCode == 70 && e.ctrlKey && (e.shiftKey != e.altKey))toggle();
	}, false);

	// For buttons
	window.addEventListener('message', function(e){
		if(e.data == prefix+'_disable')toggle(false);
		if(e.data == prefix+'_enable')toggle(true);
	}, false);
})();
